Option Strict On
Option Explicit On

Imports System.Runtime.InteropServices

' A NAG exception class which takes information from the NAGError structure
' and stuffs it into an exception class
Class NAGException
    Inherits Exception
    Public code As Integer
    Public errnum As Integer
    Public iflag As Integer
    Public ival As Integer
    Public description() As String
    Public routine As String
    Public Sub New(ByVal srname As String, ByVal fail As NagError)
        Dim enc As New System.Text.ASCIIEncoding()
        code = fail.code
        errnum = fail.errnum
        iflag = fail.iflag
        ival = fail.ival
        description = enc.GetString(fail.message).Split(CChar(vbLf))
        routine = srname
    End Sub
End Class
